<?php

/**
* inQuireREST
*
* LICENSE
*
* This source file is subject to Apache 2.0 LICENSE that is bundled
* with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.apache.org/licenses/LICENSE-2.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to integrate@etilize.com so we can send you a copy immediately.
*
* @copyright  Copyright (c) 2007-2008 Etilize USA Inc. (http://www.etilize.com)
* @license    http://www.apache.org/licenses/LICENSE-2.0.html
*/

require_once "BaseController.php";
require_once "WSConstants.php";
require_once 'Logger.php';
require_once 'InQuireWebUtil.php';

/**
 * CompareController use to compare selected products. User pass the ids to its comparisonAction method and it will send
 * WS call to get comparison data
 * 
 * @author Muhammad Saad Rashid (msrashid@etilizepak.com)
 * @version 1.0
 * 
 */
class CompareController extends BaseController
{

    public function comparisonAction ()
    {
        $productIds = $_GET["productIds"];
        $productIds = substr($productIds, 0, strlen($productIds) - 1);
        $product = explode(",", $productIds);
        /**
         * Get Number of products in Comparison
         */
        $this->view->compareCount = sizeof($product);
        /**
         * Set the width of the Page respectively
         */
        $this->view->compareWidth = (840 + ((sizeof($product) - 2) * 230));
        /**
         * Prepare paramters for WSRequest
         */
        $parameters['productIds'] = $productIds;
        /**
         * Call WebServices Gateway and return WSResponse.
         */
        Logger::info("comparisonAction Calling WS");
        $phpobject = $this->serviceRequest($parameters, WSConstants::$COMPARISON_REQUEST);
        if ($phpobject !== false) {
            /*
             * Check  the returned xml contents for Error message 
			 */
        	if(InQuireWebUtil::isErrorResponse($phpobject)){
        		$this->setWSRequestFailed($phpobject->type,$phpobject->message,"Please contact administrator with above mentioned details");
            	return;
        	}
        	
			/**
             * set views for search resutls template
             */
            $searchResultViewObjects = $this->setSearchResultViewObjects($parameters, $phpobject);
	    	if($searchResultViewObjects==WSConstants::$ERROR_RESPONSE){
               	return;
    	    }  
            /**
             * set the view and move on
             */
            $this->_request->setActionName("comparison");
        } else {
            $this->setWSRequestFailed();
        }
    }

    /**
     * Helper method used to set search result view objects or data.
     *
     * @access private
     * @param $parameters
     * @param $phpobject
     * @return it doesn't return anything
     */
    private function setSearchResultViewObjects ($parameters, $phpobject)
    {
        /**
         * set products in view
         */
        $this->view->products = $this->populateSearchResults($phpobject);
        $this->view->pcounts = count($this->populateSearchResults($phpobject));
        /**
         * set data for showing comparable attributes
         */
        $this->view->attributeGroup = $phpobject->dataSheetComparison->attributeGroup;
        /**
         * Render required templates include in search page.
         */
        $compareProductPage = $this->setCompareProductPage();
    	if($compareProductPage==WSConstants::$ERROR_RESPONSE){
               	return WSConstants::$ERROR_RESPONSE;
        }        
    }
}
?>