<?php

/**
* inQuireREST
*
* LICENSE
*
* This source file is subject to Apache 2.0 LICENSE that is bundled
* with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.apache.org/licenses/LICENSE-2.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to integrate@etilize.com so we can send you a copy immediately.
*
* @copyright  Copyright (c) 2007-2008 Etilize USA Inc. (http://www.etilize.com)
* @license    http://www.apache.org/licenses/LICENSE-2.0.html
*/

require_once 'BaseController.php';
require_once 'Logger.php';

/**
 * ErrorController is the default controller to handle different errors, such as, invalid actions,
 * database connectivity errors, and other application errors.
 *
 * @author Zaid Ansari (zaansari@etilizepak.com)
 * @version 1.0
 */
class ErrorController extends BaseController
{

    /**
     * errorAction is used to handle the following errors
     *    - Application errors
     *    - Errors in the controller chain arising from missing controller classes and/or action methods
     */
    public function errorAction ()
    {
        
		/**
         * @todo why do we use this param
         */
        $errors = $this->_getParam('error_handler');
        switch ($errors->type) {
            /**
             * @todo explain the case type
             */
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER:
                $this->view->reason = 'Invalid Controller';
                $this->view->detail = 'Invalid Controller';
                $this->view->suggestion = 'Please contact Administrator!';
                break;
            /**
             * @todo explain the case type
             */
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION:
                // 404 error -- controller or action not found
                $this->view->reason = 'Invalid Action';
                $this->view->detail = 'Provided Action Name is not valid.';
                $this->view->suggestion = 'Please contact Administrator!';
                break;
            /**
             * @todo explain the default type
             */
            default:
                $this->view->reason = 'Application Error';
                $this->view->detail = "An unexpected error occurred with your request. Please try again later.";
                $this->view->suggestion = 'Please try again later!';
                break;
        }

        //Log Error
        Logger::error($errors->exception);
                
        //Set Header page 
        $this->setHeader(true, true);
        //Set Footer page 
        $this->setFooter(true);
        
    /**
     * @todo explain how view is working in this action
     */
    }

}
