<?php

/**
* inQuirePHP
*
* LICENSE
*
* This source file is subject to Apache 2.0 LICENSE that is bundled
* with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.apache.org/licenses/LICENSE-2.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to integrate@etilize.com so we can send you a copy immediately.
*
* @copyright  Copyright (c) 2007-2008 Etilize USA Inc. (http://www.etilize.com)
* @license    http://www.apache.org/licenses/LICENSE-2.0.html
*/

require_once 'Zend/Cache.php';
require_once 'ConfigFileManagerModel.php';

class CacheModel
{
    /**
     * static property to hold singleton instance
     */
    private static $INSTANCE = false;

    /**
     * factory method to return the singleton instance
     * @return CacheModel
     */
    static public function getInstance ()
    {
        if (! CacheModel::$INSTANCE) {
            CacheModel::$INSTANCE = new CacheModel();
        }
        return CacheModel::$INSTANCE;
    }

    /**
     * constructor
     * private so only getInstance() method can instantiate
     * @return void
     */
    private function __construct ()
    {
    }

    public static function getCache ()
    {
        $config = ConfigFileManagerModel::getInstance();
        $frontendOptions = array('lifetime' => $config->getValue('cacheTime', 'App') , // cache lifetime of 12 hours
'automatic_serialization' => true);
        $backendOptions = array('cache_dir' => './cache/');// Directory where to put the cache files

        //getting a Zend_Cache_Core object
        $cache = Zend_Cache::factory('Core', 'File', $frontendOptions, $backendOptions);
        return $cache;
    }
}
?>