<?php

/**
* inQuirePHP
*
* LICENSE
*
* This source file is subject to Apache 2.0 LICENSE that is bundled
* with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.apache.org/licenses/LICENSE-2.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to integrate@etilize.com so we can send you a copy immediately.
*
* @copyright  Copyright (c) 2007-2008 Etilize USA Inc. (http://www.etilize.com)
* @license    http://www.apache.org/licenses/LICENSE-2.0.html
*/

class ConfigFileManagerModel
{
    /**
     * static property to hold singleton instance
     */
    private static $configFile = 'inquire.web.ini';
    private static $INSTANCE = false;
    private static $configArray = false;
    

    /**
     * factory method to return the singleton instance
     * @return ConfigFileManagerModel
     */
	static public function getInstance ()
    {
        if (! ConfigFileManagerModel::$INSTANCE) {
            ConfigFileManagerModel::$INSTANCE = new ConfigFileManagerModel();
        }
        return ConfigFileManagerModel::$INSTANCE;
    }

    /**
     * constructor
     * private so only getInstance() method can instantiate
     * @return void
     */
	private function __construct ()
    {
    	self::$configArray = parse_ini_file(self::$configFile, true);
    }

    /**
     * getValue('catalog', 'inQuire')
     *
     * @param object $key
     * @param object $section
     * @return value
     */
    public function getValue($key, $section) {
    	
    	$returnValue = '';
    	
    	foreach(self::$configArray as $sectionKey => $sectionValue) {
    		
    		if($sectionKey == $section) {
	    		
    			foreach($sectionValue as $iniKey => $iniValue) {
    				
    				if($iniKey == $key) {
    					$returnValue = $iniValue;
    				}
    			}
    		}
    	}
    	return $returnValue;
    }
    
}

?>