<?php

/**
* inQuirePHP
*
* LICENSE
*
* This source file is subject to Apache 2.0 LICENSE that is bundled
* with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.apache.org/licenses/LICENSE-2.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to integrate@etilize.com so we can send you a copy immediately.
*
* @copyright  Copyright (c) 2007-2008 Etilize USA Inc. (http://www.etilize.com)
* @license    http://www.apache.org/licenses/LICENSE-2.0.html
*/

require_once('ConfigFileManagerModel.php');

class DCConfigManagerModel
{
    /**
     * static property to hold singleton instance
     */
    private static $INSTANCE = false;
    public static $dcConfig = '';

    /**
     * factory method to return the singleton instance
     * @return DCConfigManagerModel
     */
    static public function getInstance ()
    {
        if (! DCConfigManagerModel::$INSTANCE) {
            DCConfigManagerModel::$INSTANCE = new DCConfigManagerModel();
            self::loadInfo();
        }
        return DCConfigManagerModel::$INSTANCE;
    }

    /**
     * @return config object
     */
    private static function loadInfo ()
    {
    	$categoryMappingFile = '';
    	
    	$config = ConfigFileManagerModel::getInstance();
    	
    	$category = $config->getValue('category', 'inQuire');
    	
    	if($category == 'mapped')
    		$categoryMappingFile = 'MappedCategoryMapping.xml';
    	else
    		$categoryMappingFile = 'CategoryMapping.xml';
    	
    	if (file_exists($categoryMappingFile)) {
            $xml = simplexml_load_file($categoryMappingFile);
            $dcInformation = array();
            foreach ($xml->DisplayCategory as $dc) {
                $catalogName = '' . $dc['name'];
                $dcMapInformation = array();
                foreach ($dc->DisplayCategoryMap as $dcMap) {
                    $categoryId = '' . $dcMap['id'];
                    unset($ecMapid);
                    foreach ($dcMap->EtilizeCategoryMapping as $ecMap) {
                        if (isset($ecMapid)) {
                            $ecMapid = $ecMapid . "," . $ecMap['id'];
                        } else {
                            $ecMapid = $ecMap['id'];
                        }
                    }
                    $dcMapInformation[$categoryId] = array($dcMap['name'] , $ecMapid);
                }
                //$dcInformation[$dckey] = $dcMapInformation;
                $dcInformation[$catalogName] = $dcMapInformation;
            }
            self::$dcConfig = $dcInformation;
        } else {
            //echo "File Not Exist";
        }
    }

    public static function getCategoryMap ($dcCategoryName)
    {
        //Get display categories for respective catalog
        $displayCategories = self::$dcConfig[$dcCategoryName];
        //Create empty array for storing display information
        $displayInfo = array();
        //Iterate through DisplayCategoryMap element in DisplayCategory child
        foreach ($displayCategories as $key => $value) {
            //Add DisplayCategoryMap 'id' and name for display in array 
            $displayInfo[] = array($key , $value[0]);
        }
        return $displayInfo;
    }

    public static function getEtilizeCategotyMap ($dcMapid, $dcCategoryName)
    {
        //Get display categories for respective catalog
        $displayCategories = self::$dcConfig[$dcCategoryName];
        //Get the Etilize Mapping id in the form of CSV for respective category($dcMapid)
        return $displayCategories[$dcMapid][1];
    }
}
?>