<?php

/**
* inQuirePHP
*
* LICENSE
*
* This source file is subject to Apache 2.0 LICENSE that is bundled
* with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.apache.org/licenses/LICENSE-2.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to integrate@etilize.com so we can send you a copy immediately.
*
* @copyright  Copyright (c) 2007-2008 Etilize USA Inc. (http://www.etilize.com)
* @license    http://www.apache.org/licenses/LICENSE-2.0.html
*/

require_once "PageLayout.php";
require_once 'ConfigFileManagerModel.php';

class DoubleBarLayout implements PageLayout
{
    private $_trailString;

    public function __construct ($trailString)
    {    	
        $this->_trailString = $trailString;
    }

    public function fetchPagedLinks ($parent, $queryVars)
    {
        //<span class="fltR a12GrayB" style="letter-spacing: 1px;"> for Dimmed
        //For selected page <span class="a12BlackB">
        //For Remaining <span class="a12BlueB">
        $currentPage = $parent->getPageNumber();
        $str = "";
        $config = ConfigFileManagerModel::getInstance();

        //Show << Sign
        if ($currentPage < 2) {
            $str .= "<span class=\"a12Gray\">";
            $str .= "&laquo;";
            $str .= "</span>";
            $str .= "&nbsp;&nbsp;|&nbsp;&nbsp;";
        } else {
            // Please dont remove below comments
            //$str.= "<a href=" . $config->getValue('rootPath', 'App') . "/search/page?trail=$this->_trailString&page=1$queryVars ><span class=\"a12BlueB\">&laquo;</span></a>";
            //$str.= "<a onclick='paginateSearchResults($config->getValue('rootPath', 'App') . "/search/page?trail=$this->_trailString&page=1$queryVars)' ><span class=\"a12BlueB\">&laquo;</span></a>";
            $url = $config->getValue('rootPath', 'App') . "/search/page?trail=" . $this->_trailString . "&page=1" . $queryVars;
            $str .= "<a onclick=paginateSearchResults('$url') ><span class=\"a12BlueB\">&laquo;</span></a>";
            $str .= "&nbsp;&nbsp;|&nbsp;&nbsp;";
        }
        //Show Previous Link
        if ($currentPage < 2) {
            $str .= "<span class=\"a12Gray\">";
            $str .= "Previous";
            $str .= "</span>";
            $str .= "&nbsp;&nbsp;|&nbsp;&nbsp;";
        } else {
            // Please dont remove below comments
            //$str.= "<a href=" . $config->getValue('rootPath', 'App') . "/search/page?trail=".$this->_trailString."&page=".($currentPage-1)."$queryVars><span class=\"a12BlueB\">Previous</span></a>";
            $url = $config->getValue('rootPath', 'App') . "/search/page?trail=" . $this->_trailString . "&page=" . ($currentPage - 1) . $queryVars;
            $str .= "<a onclick=paginateSearchResults('$url') ><span class=\"a12BlueB\">Previous</span></a>";
            $str .= "&nbsp;&nbsp;|&nbsp;&nbsp;";
        }
        //Show Page Numbers
        //Set First Page Number to (current Page - 2) 
        $startPageNo = $currentPage - 2;
        //Check if we have 2 more pages after selected page 
        if (($currentPage + 2) > $parent->fetchNumberPages()) {
            //if not than change start page no to 4 pages before the total pages
            $startPageNo = $parent->fetchNumberPages() - 4;
        }
        //		if $startPageNo is less than 1 than add the difference and start from page 1		
        if ($startPageNo < 1) {
            $startPageNo = 1;
        }
        for ($i = $startPageNo; $i <= $startPageNo + 4; $i ++) {
            //if i is less than one then continue to next iteration		
            if ($i < 1) {
                continue;
            }
            if ($i > $parent->fetchNumberPages()) {
                break;
            }
            if ($i == $currentPage) {
                $str .= "<span class=\"a12BlackB\">";
                $str .= $i;
                $str .= "</span>";
                $str .= "&nbsp;&nbsp;|&nbsp;&nbsp;";
            } else {
                // Please dont remove below comments				
                //$str.= "<a href=" . $config->getValue('rootPath', 'App') . "/search/page?trail=$this->_trailString&page=".$i."$queryVars ><span class=\"a12BlueB\">".$i."</span></a>";
                $url = $config->getValue('rootPath', 'App') . "/search/page?trail=" . $this->_trailString . "&page=" . $i . $queryVars;
                $str .= "<a onclick=paginateSearchResults('$url')><span class=\"a12BlueB\">" . $i . "</span></a>";
                $str .= "&nbsp;&nbsp;|&nbsp;&nbsp;";
            }
        } //end for		
        //Show Next 
        if ($parent->isLastPage()) {
            $str .= "<span class=\"a12Gray\">";
            $str .= "Next";
            $str .= "&nbsp;&nbsp;|&nbsp;&nbsp;";
            $str .= "</span>";
        } else {
            // Please dont remove below comments
            //$str.= "<a href=" . $config->getValue('rootPath', 'App') . "/search/page?trail=$this->_trailString&page=".($currentPage+1)."$queryVars ><span class=\"a12BlueB\">Next</span></a>";
            $url = $config->getValue('rootPath', 'App') . "/search/page?trail=" . $this->_trailString . "&page=" . ($currentPage + 1) . $queryVars;
            $str .= "<a onclick=paginateSearchResults('$url')><span class=\"a12BlueB\">Next</span></a>";
            $str .= "&nbsp;&nbsp;|&nbsp;&nbsp;";
        }
        //Show >> Sign
        if ($parent->isLastPage()) {
            $str .= "<span class=\"a12Gray\">";
            $str .= "&raquo;";
            $str .= "</span>";
        } else {
            // Please dont remove below comments			
            //$str.= "<a href=" . $config->getValue('rootPath', 'App') . "/search/page?trail=$this->_trailString&page=".($parent->fetchNumberPages())."$queryVars ><span class=\"a12BlueB\">&raquo;</span></a>";
            $url = $config->getValue('rootPath', 'App') . "/search/page?trail=" . $this->_trailString . "&page=" . ($parent->fetchNumberPages()) . $queryVars;
            $str .= "<a onclick=paginateSearchResults('$url')><span class=\"a12BlueB\">&raquo;</span></a>";
        }
        return $str;
    }
}
?>