<?php

/**
* inQuirePHP
*
* LICENSE
*
* This source file is subject to Apache 2.0 LICENSE that is bundled
* with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.apache.org/licenses/LICENSE-2.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to integrate@etilize.com so we can send you a copy immediately.
*
* @copyright  Copyright (c) 2007-2008 Etilize USA Inc. (http://www.etilize.com)
* @license    http://www.apache.org/licenses/LICENSE-2.0.html
*/

require_once "Paginated.php";
require_once "DoubleBarLayout.php";

/**
 * Paginator class load and number of pages according to the result counts. It requried
 * SearchTrail url to pass in the constructor so it will be appended in every page link
 * to request selected page data from target WebService.
 * 
 * @see SearchTrail
 * @see Paginated
 * @see DoubleBarLayout
 *
 */
class Paginator
{
    /**
     * Contains the url parameters in SearchTrail
     *
     * @var unknown_type
     */
    private $_trailString;
    /**
     * Contains reference to the Paginated object.
     *
     * @var Paginated
     */
    private $pagedResults = null;

    /**
     * Initiates Pagiantor class object
     *
     * @param unknown_type $trailString
     */
    public function __construct ($trailString)
    {
        $this->_trailString = $trailString;
    }

    /**
     * Load the Paginated object with supplied results, count and page number.
     *
     * @param array $names
     * @param int $count
     * @param int $page
     */
    public function load ($names, $count, $page)
    {
        $this->pagedResults = new Paginated($names, $count, $page);
    }

    /**
     * Set the layout of the pagination bar.
     * 
     * @return string
     */
    public function getNavigation ()
    {
        $this->pagedResults->setLayout(new DoubleBarLayout($this->_trailString));
        return $this->pagedResults->fetchPagedNavigation();
    }
}
?>