<?php

/**
* inQuirePHP
*
* LICENSE
*
* This source file is subject to Apache 2.0 LICENSE that is bundled
* with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://www.apache.org/licenses/LICENSE-2.0.html
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to integrate@etilize.com so we can send you a copy immediately.
*
* @copyright  Copyright (c) 2007-2008 Etilize USA Inc. (http://www.etilize.com)
* @license    http://www.apache.org/licenses/LICENSE-2.0.html
*/


/**
 * WSException class used to represent error produce by WSGateway class.
 */
class WSException extends Exception
{
    public static $RETRY_ERROR = 1;
    public static $BAD_GATEWAY_ERROR = 2;
    public static $REQUEST_TIMEOUT_ERROR = 3;
    public static $REQUEST_VALIDATION_ERROR = 4;
    public static $RESPONSE_VALIDATION_ERROR = 5;
    public static $SERVICE_NOT_EXISTS = 6;
    public static $SERVICE_FAILED = 7;
    public static $CATALOG_NOT_AVAILABLE = 8;
    public static $AUTHORIZATION_ERROR = 9;
    public static $OTHER = 10;

    /**
     * Constructs an instance of WSException with the specified detail message.
     * 
     * @param msg
     *            the detail message.
     */
    function __construct ($message, $code)
    {
        parent::__construct($message, $code);
    }
}
?>