<?php

require_once 'application/controllers/AuthController.php';

require_once 'PHPUnit/Framework/TestCase.php';

//require_once 'Zend/Controller/Front.php';
require_once 'Zend/Controller/Request/Http.php';
require_once 'Zend/Controller/Response/Http.php';
require_once 'Zend/Controller/Router/Rewrite.php';
//require_once 'Zend/Session.php';
//require_once 'Zend/Session/Namespace.php';



/**
 * AuthController test case.
 */
class AuthControllerTest extends PHPUnit_Framework_TestCase {
	
	/**
	 * Prepares the environment before running a test.
	 */
	protected function setUp() {
		parent::setUp ();
	}
	
	/**
	 * Cleans up the environment after running a test.
	 */
	protected function tearDown() {
		parent::tearDown ();
	}
	
	/**
	 * Test the valid login Action 
	 */
	public function testValidLoginAction() {
		$front = Zend_Controller_Front::getInstance();
        $request = new Zend_Controller_Request_Http('http://localhost:8082/inQuirePHP/index.php/auth/login');
        $request->setParam("username",'admin')->setParam("password",'admin');
        $response = new Zend_Controller_Response_Http();
        $front->returnResponse(true)->setRequest($request)->setResponse($response);
        // System shows registration screen by invoking registerAction().
        // This action renders the "register.phtml" View script. 
        $front->dispatch();
        if (isset($_SESSION["userName"])){
        	$this->assertContains('admin', $_SESSION["userName"]);
        }else{
        	$this->fail("Authentication Failed for user:"."admin");
        }
    }	

    /**
	 * Test the Login Failure Action 
	 */
	public function testLoginFailedAction() {
		$front = Zend_Controller_Front::getInstance();
        $request = new Zend_Controller_Request_Http('http://localhost:8082/inQuirePHP/index.php/auth/login');
        $request->setParam("username",'admin')->setParam("password",'admin123');
        $response = new Zend_Controller_Response_Http();
        $front->returnResponse(true)->setRequest($request)->setResponse($response);
        // System shows registration screen by invoking registerAction().
        // This action renders the "register.phtml" View script. 
        $front->dispatch();
        $this->assertContains('Incorrect username or password.', $response->getBody());
        //print $response->getBody();
    } 

    /**
	 * Test the Provide valid username and password action
	 */
    public function testProvideUserNameAction() {
		$front = Zend_Controller_Front::getInstance();
        $request = new Zend_Controller_Request_Http('http://localhost:8082/inQuirePHP/index.php/auth/login');
        $request->setParam("username",'')->setParam("password",'admin');
        $response = new Zend_Controller_Response_Http();
        $front->returnResponse(true)->setRequest($request)->setResponse($response);
        // System shows registration screen by invoking registerAction().
        // This action renders the "register.phtml" View script. 
        $front->dispatch();
        $this->assertContains('Please Provide useranme', $response->getBody());
    } 

}

