<?php

require_once '../application/models/AuthenticationModel.php';

require_once 'PHPUnit/Framework/TestCase.php';

/**
 * AuthenticationModel test case.
 */
class AuthenticationModelTest extends PHPUnit_Framework_TestCase {
	
	/**
	 * @var AuthenticationModel
	 */
	private $AuthenticationModel;
	
	/**
	 * Prepares the environment before running a test.
	 */
	protected function setUp() {
		parent::setUp ();
		
		// TODO Auto-generated AuthenticationModelTest::setUp()
		

		$this->AuthenticationModel = AuthenticationModel::getInstance();
	
	}
	
	/**
	 * Cleans up the environment after running a test.
	 */
	protected function tearDown() {
		// TODO Auto-generated AuthenticationModelTest::tearDown()
		

		$this->AuthenticationModel = null;
		
		parent::tearDown ();
	}

	public static function loginInfoProvider(){
		return array(
			array('','da'),
			array('app1','app'),	
			array('app','app')
		);
	}	
	
	/**
	 * Tests AuthenticationModel->authenticate()
	 */
	public function testAuthenticate() {
		set_include_path(get_include_path().PATH_SEPARATOR."../../../");
		$responseCode = $this->AuthenticationModel->authenticate('app','app');
		switch ($responseCode){
			case AuthenticationModel::$STATUS_ERROR_PROVIDE_USERNAME:
				//print "Provide UserName and Password\n";
				break;
				
			case AuthenticationModel::$STATUS_AUTHENTICATED:
				//print "Authenticated\n";
				break;
				
			case AuthenticationModel::$STATUS_ERROR_AUTHENTICATION_FAILED:
				//print "Invalid Username or Password\n";
				break;
				
			case AuthenticationModel::$STATUS_ERROR_DATABASE_CONNECTION_FAILED:
				//print "DB Connection Failed\n";
				break;	
					
														
		}
	}
	
	/**
	 * Tests AuthenticationModel::getInstance()
	 */
	public function testGetInstance() {
		$instance = AuthenticationModel::getInstance();
		if(!isset($instance)){
			$this->fail("Get Instance Failed");
		}		
	}

}

